/**
 * License Agreement.
 *
 * Rich Faces - Natural Ajax for Java Server Faces (JSF)
 *
 * Copyright (C) 2007 Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package com.sintecmedia.components.component;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.el.ELException;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.FacesException;
import javax.faces.component.ActionSource2;
import javax.faces.context.FacesContext;
import javax.faces.event.AbortProcessingException;
import javax.faces.event.ActionEvent;
import javax.faces.event.ActionListener;
import javax.faces.event.FacesEvent;

import org.ajax4jsf.component.AjaxInputComponent;

import com.sintecmedia.components.event.DaySelectedEvent;
import com.sintecmedia.components.event.DaySelectedListener;




/**
 * @author asmirnov@exadel.com (latest modification by $Author: igor $)
 * @version $Revision: 1872 $ $Date: 2010-05-06 11:34:42 +0300 (Thu, 06 May 2010) $
 *
 */
public abstract class UIWeekDaysButtons extends AjaxInputComponent implements ActionSource2{
	public static final String COMPONENT_TYPE = 
		"com.sintecmedia.components.component.CommandButton";
	public static final String DAY_INDEX_ATTRIBUTE = 
		COMPONENT_TYPE + ":dayIndex";

	private List<Boolean> dayFlagArray = new ArrayList<Boolean>();
	private Integer currDayIndex = null;
	
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see javax.faces.event.ActionListener#processAction(javax.faces.event.ActionEvent)
	 */
	public void processAction(ActionEvent actionEvent)
			throws AbortProcessingException {
		System.out.println("processAction entry");
//		FacesContext context = getFacesContext();
//		ELContext elContext = context.getELContext();
//		ValueExpression updateBinding = getAssignToBinding();
//		if (updateBinding != null && (!updateBinding.isReadOnly(elContext))) {
//			Object requestValue = context.getExternalContext()
//					.getRequestParameterMap().get(getName());
//			if (requestValue != null && requestValue instanceof String) {
//				Class<?> type = updateBinding.getType(elContext);
//				Converter converter = createConverter(context, type);
//				if (null != converter) {
//					requestValue = converter.getAsObject(context, this,
//							(String) requestValue);
//
//				}
//			}
//			if (null != requestValue) {
//				updateBinding.setValue(elContext, requestValue);
//			}
//
//			MethodExpression listener = getActionListener();
//			if (listener != null) {
//				listener.invoke(elContext, new Object[] {actionEvent});
//			}
//		}
	}

	
	public DaySelectedListener[] getDaySelectedListeners() {
		return (DaySelectedListener[]) getFacesListeners(
				DaySelectedListener.class);
	}

	/* (non-Javadoc)
	 * @see javax.faces.component.UIComponentBase#broadcast(javax.faces.event.FacesEvent)
	 */
	public void broadcast( FacesEvent event ) throws AbortProcessingException {
		if( event instanceof DaySelectedEvent ) {
			System.out.println("dayselectedevent.getComponent().getId():    " + event.getComponent().getId());
			DaySelectedEvent dataScrollerEvent = (DaySelectedEvent) event;
			int index = dataScrollerEvent.getDayIndex();
			System.out.println( "dayIndex=" + index );
			FacesContext context = getFacesContext();
			MethodExpression scrollerListener = getDaySelectedListener();
			if( scrollerListener != null ) {
				scrollerListener.invoke(
					context.getELContext(), new Object[]{ event } );
			}
		} else if( event instanceof ActionEvent ) {
			System.out.println("event.getComponent().getId():    " + event.getComponent().getId());
			System.out.println("this.getChildCount()   " +this.getChildCount());		
		} else {
			System.out.println("Is not implements ActionEvent" );
			super.broadcast(event);
		}
	}

	public ActionListener[] getActionListeners() {
        ActionListener al[] = (ActionListener [])
	    getFacesListeners(ActionListener.class);
        return (al);

	}
	
	public void addActionListener(ActionListener listener) {
		addFacesListener(listener);
	}
	
	public void removeActionListener(ActionListener listener) {
        removeFacesListener(listener);
	}
	
	public void setDayFlagArray(List<Boolean> dayFlagArray) {
		this.dayFlagArray = dayFlagArray;
	}

	public List<Boolean> getDayFlagArray() {
		return dayFlagArray;
	}

	public abstract MethodExpression getDaySelectedListener();

	public abstract void setDaySelectedListener(
			MethodExpression scrollerListener );

	public int getCurrentDayIndex() {
		return currDayIndex != null ? currDayIndex : 0;
	}
	public int getDayIndex() {
		 Map<String, Object> attributes = getAttributes();
		 Integer indexAttr = (Integer) attributes.get( DAY_INDEX_ATTRIBUTE );
		 if( indexAttr != null ) {
			 return indexAttr;
		 }
		 
		 if( currDayIndex != null ) {
			 return currDayIndex;
		 } 

		 ValueExpression ve = getValueExpression("dayIndex");
		 if (ve != null) {
			 try {
				 Integer pageObject = (Integer) ve.getValue(getFacesContext().getELContext());

				 if (pageObject != null) {
					 return pageObject;
				 } else {
					 return 1;
				 }
			 } catch (ELException e) {
				 throw new FacesException(e);
			 }
		 } else {
			 return 1;
		 }
	}
}
