if (!window.Richfaces) {
	window.Richfaces = {};
}

Richfaces.DaySelectedEvent = "rich:weekdaysbuttons:ondayselect";

Richfaces.DaySelector = Class.create({
	initialize: function(clientId, submitFunction) {
		this.element = $(clientId);
		this.element.component = this;
		
		this["rich:destructor"] = "destroy";
		
		Event.observe(this.element, Richfaces.DaySelectedEvent, submitFunction);
	},
	
	destroy: function() {
		this.element.component = undefined;
		this.element = undefined;
	},

	switchToDay: function(page) {
		if (typeof page != 'undefined' && page != null) {
			Event.fire(this.element, Richfaces.DaySelectedEvent, {'dayIndex': page});
		}
	},
	
	next: function() {
		this.switchToDay("next");
	},
	
	previous: function() {
		this.switchToDay("previous");
	},
	
	first: function() {
		this.switchToDay("first");
	},
	
	last: function() {
		this.switchToDay("last");
	},
	
	fastForward: function() {
		this.switchToDay("fastforward");
	},
	
	fastRewind: function() {
		this.switchToDay("fastrewind");
	}
});